from dataclasses import dataclass
from typing import Dict, List

@dataclass(frozen=True)
class Metadata:
    name: str
    labels: Dict[str, str]
    annotations: Dict[str, str] = None

@dataclass(frozen=True)
class Artifact:
    type: str
    metadata: Metadata
    data: dict
    id: str = None