from dataclasses import dataclass
from typing import List, Dict
from aiaengine.core.dataset import Dataset
from aiaengine.core.app import App
from aiaengine.core.preprocessing_pipeline import PreprocessingPipeline
@dataclass(frozen=True)
class FeatureSet:
    name: str
    feature_names: List[str]
    app: App
    description: str = None
    preprocessing_pipeline: PreprocessingPipeline = None
    preprocessed_train_dataset: Dataset = None
    preprocessed_test_dataset: Dataset = None
    id: str = None
    dataset_version: int = -1
    recommendation: List[dict] = None
    preferred_feature_types: Dict[str,str] = None