import pandas as pd
import os


def load_dataframe(path: str):
    filename, file_type = os.path.splitext(path)
    if file_type in {".json", ".jsonlines", ".jsonl"}:
        return pd.read_json(path, lines=True).astype(str)
    if file_type == ".csv":
        return pd.read_csv(path, dtype=str)
    if file_type == ".parquet":
        return pd.read_parquet(path).astype(str)

    raise ValueError("Unsupported file format: {}".format(file_type))