from aiaengine.pipeline import ServiceProvider

CLUSTER_TYPE_NONE = None
CLUSTER_TYPE_DASK = 'Dask'
CLUSTER_TYPE_SPARK = 'Spark'
CLUSTER_TYPE_DASK_CUDA = 'Dask_Cuda'

class ClusterFactory:
    def __init__(self, clusters={}) -> None:
        self.clusters = clusters

    def get_cluster(self, cluster_type: str):
        if cluster_type in self.clusters:
            return self.clusters[cluster_type]
        else:
            raise Exception(f'No registered cluster provider for type {cluster_type}. Available clusters: {self.clusters.keys()}')
class ClusterFactoryServiceProvider(ServiceProvider):
    def __init__(self, clusters={}) -> None:
        self.clusters = clusters

    def get_instance(self) -> ClusterFactory:
        return ClusterFactory(clusters=self.clusters)