from aiaengine.pipeline.converters.cuml import CumlDataset
from aiaengine.pipeline.providers import ServiceProvider
from aiaengine.pipeline.providers.dataset_reader import DatasetReader

class CumlDatasetReader:
    def read(self, dataset: DatasetReader) -> any:
        return CumlDataset(dataset=dataset).get_df()

class CumlDatasetReaderProvider(ServiceProvider):
    def __init__(self, reader: CumlDatasetReader):
        self.reader = reader

    def get_instance(self) -> CumlDatasetReader:
        return self.reader