from aiaengine.pipeline.converters.dask import DaskDataset
from aiaengine.pipeline.providers import ServiceProvider
from aiaengine.pipeline.providers.dataset_reader import DatasetReader

class DaskDatasetReader:
    def read(self, dataset: DatasetReader) -> any:
        return DaskDataset(dataset=dataset).get_df()

class DaskDatasetReaderProvider(ServiceProvider):
    def __init__(self, reader: DaskDatasetReader):
        self.reader = reader

    def get_instance(self) -> DaskDatasetReader:
        return self.reader