from aiaengine.pipeline.converters.dask_cudf import DaskCudfDataset
from aiaengine.pipeline.providers import ServiceProvider
from aiaengine.pipeline.providers.dataset_reader import DatasetReader

class DaskCudfDatasetReader:
    def read(self, dataset: DatasetReader) -> any:
        return DaskCudfDataset(dataset=dataset).get_df()


class DaskCudfDatasetReaderProvider(ServiceProvider):
    def __init__(self, reader: DaskCudfDatasetReader):
        self.reader = reader

    def get_instance(self) -> DaskCudfDatasetReader:
        return self.reader