from aiaengine.pipeline.converters.pandas import PandasDataset
from aiaengine.pipeline.providers import ServiceProvider
from aiaengine.pipeline.providers.dataset_reader import DatasetReader

class PandasDatasetReader:
    def read(self, dataset: DatasetReader) -> any:
        return PandasDataset(dataset=dataset).get_df()

class PandasDatasetReaderProvider(ServiceProvider):
    def __init__(self, reader: PandasDatasetReader):
        self.reader = reader

    def get_instance(self) -> PandasDatasetReader:
        return self.reader