# WARNING: THIS CODE IS AUTOMATICALLY GENERATED. DO NOT EDIT.
from .actions import ActionBuilder

def add_timedelta(operand=None,time_delta_sec=None):
    """
    Adds a time delta (in seconds) to one or more DateTime columns. Changes the columns in place.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'])
    
    Parameters:
    time_delta_sec: This is the time-duration in seconds to be added to one or more DateTime columns.
    """
    builder = ActionBuilder('add_timedelta')
    builder.add_input_output('operand', operand)
    if time_delta_sec is not None:
        builder.set_parameter('time_delta_sec', time_delta_sec)
    return builder.build()

def aggregate(group_by=None, operand=None,merge_back_to_original=None):
    """
    Group by the selected columns and compute aggregations within each group
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            group_by = (['input_column_1'], [])
            operand = (['input_column_1'], ['output_1'])
    
    Parameters:
    merge_back_to_original: Whether to merge the aggregation(s) back to the original data
    """
    builder = ActionBuilder('aggregate')
    builder.add_input_output('group_by', group_by)
    builder.add_input_output('operand', operand)
    if merge_back_to_original is not None:
        builder.set_parameter('merge_back_to_original', merge_back_to_original)
    return builder.build()

def aggregate_lookup(operand=None, join_criteria=None,):
    """
    Perform aggregation on another dataset and lookup the content of the summarized table
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'], ['output_1'])
            join_criteria = (['input_column_1', 'input_column_2'])
    
    
    """
    builder = ActionBuilder('aggregate_lookup')
    builder.add_input_output('operand', operand)
    builder.add_input_output('join_criteria', join_criteria)
    return builder.build()

def bin_columns(operand=None,method=None, n_bins=None, cut_positions=None, output_format=None):
    """
    This action bins one or more numeric columns by specifying the number of equally-spaced bins or a list of bin edges
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'], ['output_1'])
    
    Parameters:
    method: Whether to use equally-spaced bins or custom cut positions
    n_bins: Number of equally-spaced bins. This creates n equally-spaced bins from the minimum to maximum in the column.
    cut_positions: Custom cut positions in ascending order
    output_format: Format for output labels
    """
    builder = ActionBuilder('bin_columns')
    builder.add_input_output('operand', operand)
    if method is not None:
        builder.set_parameter('method', method)
    if n_bins is not None:
        builder.set_parameter('n_bins', n_bins)
    if cut_positions is not None:
        builder.set_parameter('cut_positions', cut_positions)
    if output_format is not None:
        builder.set_parameter('output_format', output_format)
    return builder.build()

def bin_columns_by_quantiles(operand=None,method=None, n_bins=None, split_quantiles=None, output_format=None):
    """
    This action bins one or more numeric columns by specifying the number of uniformly-split quantiles or a list of custom quantiles.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'], ['output_1'])
    
    Parameters:
    method: Whether to use uniformly-split quantiles or custom split quantiles
    n_bins: Number of uniformly-split quantiles. This creates n bins based on uniformly-split quantiles from 0 to 1
    split_quantiles: Custom split quantiles in ascending order
    output_format: Format for output labels
    """
    builder = ActionBuilder('bin_columns_by_quantiles')
    builder.add_input_output('operand', operand)
    if method is not None:
        builder.set_parameter('method', method)
    if n_bins is not None:
        builder.set_parameter('n_bins', n_bins)
    if split_quantiles is not None:
        builder.set_parameter('split_quantiles', split_quantiles)
    if output_format is not None:
        builder.set_parameter('output_format', output_format)
    return builder.build()

def change_text_case(operand=None,case=None):
    """
    Changes text columns to selected text case (uppercase, lowercase, etc.)
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'])
    
    Parameters:
    case: The required change in case of values where "Upper" converts all to uppercase, "Lower" converts all to lowercase and "Capitalize" converts first character to uppercase and remaining to lowercase.
    """
    builder = ActionBuilder('change_text_case')
    builder.add_input_output('operand', operand)
    if case is not None:
        builder.set_parameter('case', case)
    return builder.build()

def combine_boolean(operand=None,operator=None):
    """
    Combines multiple boolean columns using and/or operator
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'], ['output_1'])
    
    Parameters:
    operator: Operator used to combine boolean columns
    """
    builder = ActionBuilder('combine_boolean')
    builder.add_input_output('operand', operand)
    if operator is not None:
        builder.set_parameter('operator', operator)
    return builder.build()

def compute_periodic_windowed_aggregations(partition_by=None, timestamp=None, operand=None, snapshot_time=None,output_frequency=None, output_frequency_time_unit=None, max_inactive_periods=None):
    """
    Generate features based on windowed aggregation (count, sum, mean, etc.) at regular intervals from events-like data with timestamps for each unique entity defined by the partition-by keys. 
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            partition_by = (['input_column_1'])
            timestamp = (['input_column_1'])
            operand = (['input_column_1'], ['output_1'])
            snapshot_time = ([, ['output_1'])
    
    Parameters:
    output_frequency: Time interval between consecutive records in the output
    output_frequency_time_unit: None
    max_inactive_periods: The maximum number of additional periods in which an entity can appear in the output after the last event seen from it. This means that the generation of features for the entity will stop after a certain number of periods of inactivity.
    """
    builder = ActionBuilder('compute_periodic_windowed_aggregations')
    builder.add_input_output('partition_by', partition_by)
    builder.add_input_output('timestamp', timestamp)
    builder.add_input_output('operand', operand)
    builder.add_input_output('snapshot_time', snapshot_time)
    if output_frequency is not None:
        builder.set_parameter('output_frequency', output_frequency)
    if output_frequency_time_unit is not None:
        builder.set_parameter('output_frequency_time_unit', output_frequency_time_unit)
    if max_inactive_periods is not None:
        builder.set_parameter('max_inactive_periods', max_inactive_periods)
    return builder.build()

def compute_window_function(partition_by=None, order_by=None, operand=None,window_start=None, start_position=None, window_end=None, end_position=None):
    """
    Compute functions such as cumulative sum, rolling mean, etc. by specifying a window and desired functions with their inputs. Unbounded, shrinking, expanding and rolling windows are supported, with optional partitioning and ordering
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            partition_by = (['input_column_1'])
            order_by = (['input_column_1'])
            operand = (['input_column_1'], ['output_1'])
    
    Parameters:
    window_start: Whether to set window start unbounded or a specified position relative to current row, with unbounded by default
    start_position: Position from which window starts, relative to the current row (0). Negative and positive numbers indicate the number of rows that precede and follow the current row respectively.
    window_end: Whether to set window end unbounded or a specified position relative to current row, with unbounded by default
    end_position: Position from which window ends, relative to the current row (0). Negative and positive numbers indicate the number of rows that precede and follow the current row respectively.
    """
    builder = ActionBuilder('compute_window_function')
    builder.add_input_output('partition_by', partition_by)
    builder.add_input_output('order_by', order_by)
    builder.add_input_output('operand', operand)
    if window_start is not None:
        builder.set_parameter('window_start', window_start)
    if start_position is not None:
        builder.set_parameter('start_position', start_position)
    if window_end is not None:
        builder.set_parameter('window_end', window_end)
    if end_position is not None:
        builder.set_parameter('end_position', end_position)
    return builder.build()

def concat_cols_delim(operand=None,delimiter=None):
    """
    Concatenates one or more text columns with a specified delimiter.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'], ['output_1'])
    
    Parameters:
    delimiter: Delimiter to be appended between concatenated values
    """
    builder = ActionBuilder('concat_cols_delim')
    builder.add_input_output('operand', operand)
    if delimiter is not None:
        builder.set_parameter('delimiter', delimiter)
    return builder.build()

def convert_categorical_to_text(operand=None,):
    """
    Converts selected categorical columns to text type
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'])
    
    
    """
    builder = ActionBuilder('convert_categorical_to_text')
    builder.add_input_output('operand', operand)
    return builder.build()

def convert_numeric_to_datetime(operand=None,units=None, rel_to=None):
    """
    Converts the given numeric columns to DateTime type, interpreting them as offset values in the given unit since the specified epoch in the UTC timezone.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'])
    
    Parameters:
    units: Specifies the unit of time that the values in the numeric column represent.
    rel_to: Specifies the "origin" UTC DateTime. The conversion from Numeric to DateTime shall be relative to this "origin".
    """
    builder = ActionBuilder('convert_numeric_to_datetime')
    builder.add_input_output('operand', operand)
    if units is not None:
        builder.set_parameter('units', units)
    if rel_to is not None:
        builder.set_parameter('rel_to', rel_to)
    return builder.build()

def convert_numeric_to_text(operand=None,precision=None, width=None, comma=None, zero_pad=None, left_justify=None):
    """
    Converts the selected numeric columns to Text type using a specific formatting.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'])
    
    Parameters:
    precision: Number of digits after decimal point. (Not applicable for integer)
    width: Number of whitespaces padding the output strings. Per value it could range between 0 to the user supplied width, depending on the length of the value.
    comma: Formats the number with commas.
    zero_pad: If enabled, will zero pad (from the LEFT) the remaining empty spaces if the length of the number is shorter than the defined width.
    left_justify: Left-justifies the result (pad space on the right)
    """
    builder = ActionBuilder('convert_numeric_to_text')
    builder.add_input_output('operand', operand)
    if precision is not None:
        builder.set_parameter('precision', precision)
    if width is not None:
        builder.set_parameter('width', width)
    if comma is not None:
        builder.set_parameter('comma', comma)
    if zero_pad is not None:
        builder.set_parameter('zero_pad', zero_pad)
    if left_justify is not None:
        builder.set_parameter('left_justify', left_justify)
    return builder.build()

def convert_text_to_datetime(operand=None,datetime_format=None, timezone=None):
    """
    Convert the selected columns to DateTime type, given the specified format string
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'])
    
    Parameters:
    datetime_format: DateTime format string in the strftime format.
    timezone: Specifies the timezone the DateTimes belong to
    """
    builder = ActionBuilder('convert_text_to_datetime')
    builder.add_input_output('operand', operand)
    if datetime_format is not None:
        builder.set_parameter('datetime_format', datetime_format)
    if timezone is not None:
        builder.set_parameter('timezone', timezone)
    return builder.build()

def convert_to_categorical(operand=None,):
    """
    Converts the selected columns to categorical type.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'])
    
    
    """
    builder = ActionBuilder('convert_to_categorical')
    builder.add_input_output('operand', operand)
    return builder.build()

def convert_to_float(operand=None,):
    """
    Converts the selected columns to numeric type.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'])
    
    
    """
    builder = ActionBuilder('convert_to_float')
    builder.add_input_output('operand', operand)
    return builder.build()

def convert_to_json_array(operand=None,):
    """
    Converts specified columns to "JSONArray" type, implying that the values in the column are expected to be JSON strings of arrays.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'])
    
    
    """
    builder = ActionBuilder('convert_to_json_array')
    builder.add_input_output('operand', operand)
    return builder.build()

def convert_to_json_object(operand=None,):
    """
    Converts input columns to "JSONObject" type, implying that the values in the column are expected to be JSON strings containing objects with attributes and values.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'])
    
    
    """
    builder = ActionBuilder('convert_to_json_object')
    builder.add_input_output('operand', operand)
    return builder.build()

def copy(operand=None,):
    """
    Creates a copy of the specified columns OR column groups
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'], ['output_1'])
    
    
    """
    builder = ActionBuilder('copy')
    builder.add_input_output('operand', operand)
    return builder.build()

def cyclic_encode(operand=None,period=None):
    """
    A directive that receives one or more columns that are cyclical in nature. denote the column as 'x' and the period of the column as 'p'. For each such columns, creates 2 new columns which are: x_sin = ``sin(frac{2\pix}p)``, x_cos = ``cos(frac{2\pix}p)``
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'], ['output_1', 'output_2'])
    
    Parameters:
    period: The period of the cyclic feature
    """
    builder = ActionBuilder('cyclic_encode')
    builder.add_input_output('operand', operand)
    if period is not None:
        builder.set_parameter('period', period)
    return builder.build()

def create_missing_flag(operand=None,):
    """
    For every input column, create a boolean column flagging the locations of missing values.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'], ['output_1'])
    
    
    """
    builder = ActionBuilder('create_missing_flag')
    builder.add_input_output('operand', operand)
    return builder.build()

def create_new_column_with_formula(output=None,expression=None):
    """
    Creates a new column with any user-entered formula. Common Excel/SQL functions and operators for manipulating Numeric, DateTime, Text, and Boolean values are permitted. For a full list of allowed functions, see documentation.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            output = ([, ['output_1'])
    
    Parameters:
    expression: A formula involving column names. For example: 'column_B / column_A + log(column_D * 2)'
    """
    builder = ActionBuilder('create_new_column_with_formula')
    builder.add_input_output('output', output)
    if expression is not None:
        builder.set_parameter('expression', expression)
    return builder.build()

def regex_match(operand=None,pattern=None):
    """
    Creates an output boolean column which is the result of matching the input column against a regex pattern
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'], ['output_1'])
    
    Parameters:
    pattern: A regular expression pattern for the matching
    """
    builder = ActionBuilder('regex_match')
    builder.add_input_output('operand', operand)
    if pattern is not None:
        builder.set_parameter('pattern', pattern)
    return builder.build()

def decode_base64(operand=None,charset=None):
    """
    Every input column is assumed to be encoded using Base64-encoding. Decode it into thecharacter set (e.g. UTF8) specified. Store the decoded values in the output column
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'], ['output_1'])
    
    Parameters:
    charset: The encoding to convert the decoded bytes to. This is the charset encoding of the original strings before they were base64 encoded
    """
    builder = ActionBuilder('decode_base64')
    builder.add_input_output('operand', operand)
    if charset is not None:
        builder.set_parameter('charset', charset)
    return builder.build()

def diff_datetime(operand=None,units=None):
    """
    Calculates the time difference in seconds between two DateTime columns
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1', 'input_column_2'], ['output_1'])
    
    Parameters:
    units: Specifies the units of the time difference result
    """
    builder = ActionBuilder('diff_datetime')
    builder.add_input_output('operand', operand)
    if units is not None:
        builder.set_parameter('units', units)
    return builder.build()

def drop(operand=None,):
    """
    Drop columns
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'])
    
    
    """
    builder = ActionBuilder('drop')
    builder.add_input_output('operand', operand)
    return builder.build()

def extract_all_regex_matches(operand=None,pattern=None):
    """
    For each input column, creates a new column of Text type containing all the sub-strings in the corresponding input matching the specified regular expression.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'], ['output_1'])
    
    Parameters:
    pattern: The pattern to be found, as a Perl-Compatible Regular Expression. Note that at present, only whole matches are extracted and capturing groups are not supported.
    """
    builder = ActionBuilder('extract_all_regex_matches')
    builder.add_input_output('operand', operand)
    if pattern is not None:
        builder.set_parameter('pattern', pattern)
    return builder.build()

def extract_am_pm(operand=None,):
    """
    Extracts the AM/PM value for rows of a DateTime column
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'], ['output_1'])
    
    
    """
    builder = ActionBuilder('extract_am_pm')
    builder.add_input_output('operand', operand)
    return builder.build()

def extract_capture_groups(input_to_parse=None, capture_group=None,pattern=None):
    """
    Extracts one or more regex capture groups into multiple columns.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            input_to_parse = (['input_column_1'], [])
            capture_group = ([, ['output_1'])
    
    Parameters:
    pattern: A regular expression pattern containing one or more capture groups
    """
    builder = ActionBuilder('extract_capture_groups')
    builder.add_input_output('input_to_parse', input_to_parse)
    builder.add_input_output('capture_group', capture_group)
    if pattern is not None:
        builder.set_parameter('pattern', pattern)
    return builder.build()

def extract_day_of_month_number(operand=None,):
    """
    Extract the day of month as a number from 1 to 31
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'], ['output_1'])
    
    
    """
    builder = ActionBuilder('extract_day_of_month_number')
    builder.add_input_output('operand', operand)
    return builder.build()

def extract_day_of_week_name(operand=None,):
    """
    Extract the name of the day in week ('Monday' to 'Sunday')
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'], ['output_1'])
    
    
    """
    builder = ActionBuilder('extract_day_of_week_name')
    builder.add_input_output('operand', operand)
    return builder.build()

def extract_day_of_week_number(operand=None,):
    """
    Extract the day of week as a number ('Sunday' = 1, 'Saturday' = 7)
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'], ['output_1'])
    
    
    """
    builder = ActionBuilder('extract_day_of_week_number')
    builder.add_input_output('operand', operand)
    return builder.build()

def extract_from_json_by_path(operand=None,path=None):
    """
    Extract from JSON by the path. Will return `null` if the path isn't found
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'], ['output_1'])
    
    Parameters:
    path: The path of the value to extract
    """
    builder = ActionBuilder('extract_from_json_by_path')
    builder.add_input_output('operand', operand)
    if path is not None:
        builder.set_parameter('path', path)
    return builder.build()

def extract_hour(operand=None,):
    """
    Extract hour of the day as a number from 0 to 23
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'], ['output_1'])
    
    
    """
    builder = ActionBuilder('extract_hour')
    builder.add_input_output('operand', operand)
    return builder.build()

def extract_minutes(operand=None,):
    """
    Extract minutes after the hour as a number from 0 to 59
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'], ['output_1'])
    
    
    """
    builder = ActionBuilder('extract_minutes')
    builder.add_input_output('operand', operand)
    return builder.build()

def extract_month_name(operand=None,):
    """
    Extracts the months names of a DateTime column
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'], ['output_1'])
    
    
    """
    builder = ActionBuilder('extract_month_name')
    builder.add_input_output('operand', operand)
    return builder.build()

def extract_month_number(operand=None,):
    """
    Extract the month as a number from 1 to 12
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'], ['output_1'])
    
    
    """
    builder = ActionBuilder('extract_month_number')
    builder.add_input_output('operand', operand)
    return builder.build()

def extract_quarter(operand=None,):
    """
    Extract the quarter (3-month period) of the year in which the dates fall as an integer from 1 to 4.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'], ['output_1'])
    
    
    """
    builder = ActionBuilder('extract_quarter')
    builder.add_input_output('operand', operand)
    return builder.build()

def extract_seconds(operand=None,):
    """
    Extract seconds after the minute as a number from 0 to 59
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'], ['output_1'])
    
    
    """
    builder = ActionBuilder('extract_seconds')
    builder.add_input_output('operand', operand)
    return builder.build()

def extract_timestamp(operand=None,):
    """
    Extracts the POSIX timestamp. (Number of seconds since January 1st, 1970
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'], ['output_1'])
    
    
    """
    builder = ActionBuilder('extract_timestamp')
    builder.add_input_output('operand', operand)
    return builder.build()

def extract_utc_offset(operand=None,date_format=None):
    """
    Extracts the UTC offset (in hours) from timezone aware string timestamps
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'], ['output_1'])
    
    Parameters:
    date_format: The date_format of the column
    """
    builder = ActionBuilder('extract_utc_offset')
    builder.add_input_output('operand', operand)
    if date_format is not None:
        builder.set_parameter('date_format', date_format)
    return builder.build()

def extract_utc_offset_tz(operand=None,):
    """
    Extracts the offset (in hours) from UTC, given the UTC DateTime column and the timezone name column.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1', 'input_column_2'], ['output_1'])
    
    
    """
    builder = ActionBuilder('extract_utc_offset_tz')
    builder.add_input_output('operand', operand)
    return builder.build()

def extract_url_parts(col_to_parse=None, parse_result_item=None,host=None, path=None, query=None, ref=None, protocol=None, file=None, authority=None, userinfo=None):
    """
    Extracts URL components from a given column containing URL strings
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            col_to_parse = (['input_column_1'], [])
            parse_result_item = ([, ['output_1'])
    
    Parameters:
    host: Given an example URL: `https://john.doe@www.example.com:123/forum/questions/` the `host` field is: `www.example.com`
    path: Given an example URL: `https://john.doe@www.example.com:123/forum/questions/` the `path` field is: `forum/questions/`
    query: Given an example URL: `http://www.abc.com/forum/questions/?tag=networking&order=newest` the `query` field is: `tag=networking&order=newest`
    ref: Extracts the URL `ref` field
    protocol: Given an example URL: `http://www.abc.com/` the `protocol` field is: `http`
    file: Given an example URL: `http://www.abc.com:80/path/to/myfile.html`the `file` field is: `/path/to/myfile.html`
    authority: Given an example URL: `https://john.doe@www.example.com:123/forum/questions/` the `authority` field is: `john.doe@www.example.com:123`
    userinfo: Given an example URL: `https://john.doe@www.example.com` the `userinfo` field is: `john.doe`
    """
    builder = ActionBuilder('extract_url_parts')
    builder.add_input_output('col_to_parse', col_to_parse)
    builder.add_input_output('parse_result_item', parse_result_item)
    if host is not None:
        builder.set_parameter('host', host)
    if path is not None:
        builder.set_parameter('path', path)
    if query is not None:
        builder.set_parameter('query', query)
    if ref is not None:
        builder.set_parameter('ref', ref)
    if protocol is not None:
        builder.set_parameter('protocol', protocol)
    if file is not None:
        builder.set_parameter('file', file)
    if authority is not None:
        builder.set_parameter('authority', authority)
    if userinfo is not None:
        builder.set_parameter('userinfo', userinfo)
    return builder.build()

def extract_week_number_in_year(operand=None,):
    """
    Extracts the week number (between 1-52)
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'], ['output_1'])
    
    
    """
    builder = ActionBuilder('extract_week_number_in_year')
    builder.add_input_output('operand', operand)
    return builder.build()

def extract_year(operand=None,):
    """
    Extract the year as a number
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'], ['output_1'])
    
    
    """
    builder = ActionBuilder('extract_year')
    builder.add_input_output('operand', operand)
    return builder.build()

def fill_missing_values(operand=None,method=None, fill_value=None):
    """
    Fill missing or null values by a specified imputation method
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'])
    
    Parameters:
    method: Method for fill missing values in input columns
    fill_value: Value to fill when method is specified as constant
    """
    builder = ActionBuilder('fill_missing_values')
    builder.add_input_output('operand', operand)
    if method is not None:
        builder.set_parameter('method', method)
    if fill_value is not None:
        builder.set_parameter('fill_value', fill_value)
    return builder.build()

def window_fill_null_by_nearest(partition_by=None, order_by=None, operand=None,method=None):
    """
    Fill null with the nearest non-null values in either preceding or following rows after ordering, optionally with partitioning
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            partition_by = (['input_column_1'])
            order_by = (['input_column_1'])
            operand = (['input_column_1'])
    
    Parameters:
    method: Whether to use the nearest value in preceding or following rows
    """
    builder = ActionBuilder('window_fill_null_by_nearest')
    builder.add_input_output('partition_by', partition_by)
    builder.add_input_output('order_by', order_by)
    builder.add_input_output('operand', operand)
    if method is not None:
        builder.set_parameter('method', method)
    return builder.build()

def filter_rows_with_formula(condition=None):
    """
    Filter rows in data by keeping only rows that satisfy the condition specified in user-entered formula. Common Excel/SQL functions and operators for manipulating Numeric, DateTime, Text, and Boolean values are permitted. For a full list of allowed functions, see documentation. 

NOTE: The formula entered must evaluate to a boolean value.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
    
    Parameters:
    condition: The condition under which the rows are to be kept, entered as a formula.
    """
    builder = ActionBuilder('filter_rows_with_formula')
    if condition is not None:
        builder.set_parameter('condition', condition)
    return builder.build()

def find_replace(operand=None,replacements=None, match_case=None, positional_match=None):
    """
    Finds and replaces the specified strings in the input column(s) according to the given mapping
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'])
    
    Parameters:
    replacements: Mapping between the search strings and their replacements
    match_case: Whether the matches are case sensitive
    positional_match: Matches the search only if a match is found in the specified position in the string
    """
    builder = ActionBuilder('find_replace')
    builder.add_input_output('operand', operand)
    if replacements is not None:
        builder.set_parameter('replacements', replacements)
    if match_case is not None:
        builder.set_parameter('match_case', match_case)
    if positional_match is not None:
        builder.set_parameter('positional_match', positional_match)
    return builder.build()

def find_datetime_interval(operand=None,interval_size=None):
    """
    Given a datetime column and interval size (in hours/minutes/seconds), finds the interval (time slot) in which the value lies. The output interval is given in the form of two columns, the earlier limit and later limit. Discretisation/binning of datetime values can be performed using this action.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'], ['output_1', 'output_2'])
    
    Parameters:
    interval_size: Upper/lower bounds to round towards in order to find the interval. E.g.: 14:53:15 --> [14:45:00, 15:00:00] when using "quarter_hour" resolution
    """
    builder = ActionBuilder('find_datetime_interval')
    builder.add_input_output('operand', operand)
    if interval_size is not None:
        builder.set_parameter('interval_size', interval_size)
    return builder.build()

def get_dst_indicator(operand=None,):
    """
    Generates a boolean column which indicates if a localized timestamp column (represented by the combination of two columns: A UTC DateTime column and an IANA timezone name column) has an active daylight saving.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1', 'input_column_2'], ['output_1'])
    
    
    """
    builder = ActionBuilder('get_dst_indicator')
    builder.add_input_output('operand', operand)
    return builder.build()

def get_local_time(operand=None,):
    """
    Generates local time given the UTC timestamp and the timezone's offset in hours.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1', 'input_column_2'], ['output_1'])
    
    
    """
    builder = ActionBuilder('get_local_time')
    builder.add_input_output('operand', operand)
    return builder.build()

def get_named_entities_from_text(operand=None,):
    """
    Extracts named entities mentioned in input text column into the corresponding output text column as JSON string. The JSON string represents a dictionary-mapping between entity types to the coresponding list of entity mentions in the text.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'], ['output_1'])
    
    
    """
    builder = ActionBuilder('get_named_entities_from_text')
    builder.add_input_output('operand', operand)
    return builder.build()

def get_sentiment_scores_from_text(operand=None,):
    """
    Analyses the sentiment expressed in the input text columns and creates 3 output columns that reflect the strength (a number between 0 to 1, where 1 is the strongest) of positive, neutral and  negative sentiment expressed in input text.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'], ['output_1', 'output_2', 'output_3'])
    
    
    """
    builder = ActionBuilder('get_sentiment_scores_from_text')
    builder.add_input_output('operand', operand)
    return builder.build()

def get_tz_name(operand=None,):
    """
    Generates a list of timezone names matching the pair of a UTC DateTime column and a numeric UTC offset (in hours) column. The list will be serialised as a JSON Array string.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1', 'input_column_2'], ['output_1'])
    
    
    """
    builder = ActionBuilder('get_tz_name')
    builder.add_input_output('operand', operand)
    return builder.build()

def get_tz_name_from_geolocation(operand=None,):
    """
    Given the geolocation as a pair of numeric columns (latitude and longitude), creates a column of timezone names of each geolocation. Returns null values if no matching timezone is found, or if the geo coordinates are invalid.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1', 'input_column_2'], ['output_1'])
    
    
    """
    builder = ActionBuilder('get_tz_name_from_geolocation')
    builder.add_input_output('operand', operand)
    return builder.build()

def indicate_anomalous_values(operand=None,decision_mode=None, low_percentile=None, high_percentile=None, ipr_factor=None):
    """
    Creates boolean flag columns indicating outliers in the corresponding input columns, using interpercentile range method.E.g. denoting Q1 as the 1st quartile, Q3 as the 3rd quartile and IQR = Q3 - Q1, values smaller than Q1 - 1.5*IQR or larger than Q3 + 1.5IQR will be flagged as outliers.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'], ['output_1'])
    
    Parameters:
    decision_mode: How the decision is made for declaring an anomaly: For "Upper threshold": only values larger than the upper threshold will be declared as anomalies. For "Lower threshold": only values lower than the lower threshold will be declared as anomalies. For "Lower and upper threshold": values below the lower threshold and above the upper threshold will be declared as anomalies.
    low_percentile: The percentile P1 such that all values smaller than P1-alpha*IPR will be flagged as outliers. By default, P1 equals Q1 (first quartile).
    high_percentile: The percentile P2 such that all values larger than P2+alpha*IPR will be flagged as outliers. By default, P2 equals Q3 (3rd quartile).
    ipr_factor: The interpercentile range (denoted as IPR) equals P2-P1, where P2 and P1 are correspondingly the high and low percentiles. The factor is defined as 'alpha' in the formulas: P1 - alpha * IPR and P2 + alpha * IPR which determine the low and high thresholds for outliers detections. Values above/below these thresholds will be flagged as outliers
    """
    builder = ActionBuilder('indicate_anomalous_values')
    builder.add_input_output('operand', operand)
    if decision_mode is not None:
        builder.set_parameter('decision_mode', decision_mode)
    if low_percentile is not None:
        builder.set_parameter('low_percentile', low_percentile)
    if high_percentile is not None:
        builder.set_parameter('high_percentile', high_percentile)
    if ipr_factor is not None:
        builder.set_parameter('ipr_factor', ipr_factor)
    return builder.build()

def join(join_keys=None, retained_columns=None,join_type=None):
    """
    Joins another dataset to current dataset given one or more join keys, retaining the specified selection of columns from both datasets.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            join_keys = (['input_column_1', 'input_column_2'])
            retained_columns = (['input_column_1', 'input_column_2'], ['output_1', 'output_2'])
    
    Parameters:
    join_type: Specifies how to perform the join.
    """
    builder = ActionBuilder('join')
    builder.add_input_output('join_keys', join_keys)
    builder.add_input_output('retained_columns', retained_columns)
    if join_type is not None:
        builder.set_parameter('join_type', join_type)
    return builder.build()

def lookup_from(lookup=None, join_criteria=None, order_secondary_by=None,multi_match_resolution=None):
    """
    Creates specified columns by looking them up from a second dataset. Results in null values if there is no match in the second dataset for a particular record.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            lookup = (['input_column_1'], ['output_1', 'output_2'])
            join_criteria = (['input_column_1', 'input_column_2'])
            order_secondary_by = (['input_column_1'])
    
    Parameters:
    multi_match_resolution: What row to use in case of multiple rows are matching in the other dataset under the specified criteria.
    """
    builder = ActionBuilder('lookup_from')
    builder.add_input_output('lookup', lookup)
    builder.add_input_output('join_criteria', join_criteria)
    builder.add_input_output('order_secondary_by', order_secondary_by)
    if multi_match_resolution is not None:
        builder.set_parameter('multi_match_resolution', multi_match_resolution)
    return builder.build()

def map_to_text(operand=None,mapping=None):
    """
    Replace values of input column(s) using a given mapping.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'])
    
    Parameters:
    mapping: Value that will be replaced and the replacement.
    """
    builder = ActionBuilder('map_to_text')
    builder.add_input_output('operand', operand)
    if mapping is not None:
        builder.set_parameter('mapping', mapping)
    return builder.build()

def normalize_text(operand=None,steps_to_execute=None):
    """
    Normalizes a text column by performing one or more normalization steps such as removing non text content or stemming the words.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'])
    
    Parameters:
    steps_to_execute: The required normalization steps
    """
    builder = ActionBuilder('normalize_text')
    builder.add_input_output('operand', operand)
    if steps_to_execute is not None:
        builder.set_parameter('steps_to_execute', steps_to_execute)
    return builder.build()

def parse_json_objects(json_in=None, parsed_out=None,allow_single_quotes=None):
    """
    Parses each value in the input column as a JSON object, whose schema is specified by the user. Each attribute is extracted as one output column. All output columns will contain null values wherever the Text string is not parsable as a JSON object. If parsable but one or more of the specified attributes is missing or of incompatible type, their corresponding  output columns will contain null values.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            json_in = (['input_column_1'], [])
            parsed_out = ([], ['output_1'])
    
    Parameters:
    allow_single_quotes: Whether to allow single quoted JSONs
    """
    builder = ActionBuilder('parse_json_objects')
    builder.add_input_output('json_in', json_in)
    builder.add_input_output('parsed_out', parsed_out)
    if allow_single_quotes is not None:
        builder.set_parameter('allow_single_quotes', allow_single_quotes)
    return builder.build()

def parse_strings_as_null(operand=None,strings_to_parse=None):
    """
    Parses the specified strings in given column(s) as null values
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'])
    
    Parameters:
    strings_to_parse: The list of strings that will be parsed as null
    """
    builder = ActionBuilder('parse_strings_as_null')
    builder.add_input_output('operand', operand)
    if strings_to_parse is not None:
        builder.set_parameter('strings_to_parse', strings_to_parse)
    return builder.build()

def pivot(group_by=None, pivot=None, operand=None,pivot_values=None):
    """
    Creates a pivot table with specified group-by (index) columns and a pivot column. One column is created for each combination of input column and pivot value.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            group_by = (['input_column_1'])
            pivot = (['input_column_1'])
            operand = (['input_column_1'], ['output_1'])
    
    Parameters:
    pivot_values: List of values that are converted to columns in the output
    """
    builder = ActionBuilder('pivot')
    builder.add_input_output('group_by', group_by)
    builder.add_input_output('pivot', pivot)
    builder.add_input_output('operand', operand)
    if pivot_values is not None:
        builder.set_parameter('pivot_values', pivot_values)
    return builder.build()

def window_rank(partition_by=None, order_by=None, operand=None,rank_method=None):
    """
    Rank rows after ordering and optional partitioning
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            partition_by = (['input_column_1'])
            order_by = (['input_column_1'])
            operand = ([, ['output_1'])
    
    Parameters:
    rank_method: Method used to get the rank
    """
    builder = ActionBuilder('window_rank')
    builder.add_input_output('partition_by', partition_by)
    builder.add_input_output('order_by', order_by)
    builder.add_input_output('operand', operand)
    if rank_method is not None:
        builder.set_parameter('rank_method', rank_method)
    return builder.build()

def remove_prefix(operand=None,prefix_string=None):
    """
    Removes a string prefix from the rows of a chosen string column, if the string is found.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'])
    
    Parameters:
    prefix_string: The prefix string to be stripped
    """
    builder = ActionBuilder('remove_prefix')
    builder.add_input_output('operand', operand)
    if prefix_string is not None:
        builder.set_parameter('prefix_string', prefix_string)
    return builder.build()

def remove_punctuation(operand=None,punc_symbols=None):
    """
    Removes the punctuation from the rows of a chosen string column. The punctuation symbols to remove are given by the user as a string
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'])
    
    Parameters:
    punc_symbols: The punctuation symbols to strip
    """
    builder = ActionBuilder('remove_punctuation')
    builder.add_input_output('operand', operand)
    if punc_symbols is not None:
        builder.set_parameter('punc_symbols', punc_symbols)
    return builder.build()

def remove_suffix(operand=None,suffix_string=None):
    """
    Removes a string suffix from the rows of a chosen string column, if the string is found.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'])
    
    Parameters:
    suffix_string: The suffix string to strip
    """
    builder = ActionBuilder('remove_suffix')
    builder.add_input_output('operand', operand)
    if suffix_string is not None:
        builder.set_parameter('suffix_string', suffix_string)
    return builder.build()

def rename(operand=None,):
    """
    Renames specified columns
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'], ['output_1'])
    
    
    """
    builder = ActionBuilder('rename')
    builder.add_input_output('operand', operand)
    return builder.build()

def resample_time_series(time_index=None, operand=None,sampling_interval=None, time_unit=None):
    """
    Resample data with a time-index column into a regular time series, with a specified aggregation function for each input column. Null-value interpolation is applied.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            time_index = (['input_column_1'])
            operand = (['input_column_1'], ['output_1'])
    
    Parameters:
    sampling_interval: Interval/Duration between successive records
    time_unit: Unit for the time interval
    """
    builder = ActionBuilder('resample_time_series')
    builder.add_input_output('time_index', time_index)
    builder.add_input_output('operand', operand)
    if sampling_interval is not None:
        builder.set_parameter('sampling_interval', sampling_interval)
    if time_unit is not None:
        builder.set_parameter('time_unit', time_unit)
    return builder.build()

def round_datetime(operand=None,round_to=None):
    """
    Rounds a DateTime column (in place) to 15, 30 or 60 minutes
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'])
    
    Parameters:
    round_to: Time rounding resolution. E.g. for "half_hour", 14:39:11 --> 14:30:00
    """
    builder = ActionBuilder('round_datetime')
    builder.add_input_output('operand', operand)
    if round_to is not None:
        builder.set_parameter('round_to', round_to)
    return builder.build()

def window_shift(partition_by=None, order_by=None, operand=None,n_rows=None):
    """
    Shift rows for input columns after ordering, optionally with partitioning, by a specified value indicating the numberof shifted rows and shifted direction
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            partition_by = (['input_column_1'])
            order_by = (['input_column_1'])
            operand = (['input_column_1'], ['output_1'])
    
    Parameters:
    n_rows: Number of rows to shift where positive values indicate moving downwards (lag) and negative values refer to moving moving upwards (lead)
    """
    builder = ActionBuilder('window_shift')
    builder.add_input_output('partition_by', partition_by)
    builder.add_input_output('order_by', order_by)
    builder.add_input_output('operand', operand)
    if n_rows is not None:
        builder.set_parameter('n_rows', n_rows)
    return builder.build()

def sort_on_columns(sort_by=None,):
    """
    Sort the dataset based on the input columns in a specified order (ascending/descending)
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            sort_by = (['input_column_1'])
    
    
    """
    builder = ActionBuilder('sort_on_columns')
    builder.add_input_output('sort_by', sort_by)
    return builder.build()

def split_and_unpack(operand=None, output_pos=None,delimiter=None, use_regex=None):
    """
    Splits the text content in the input column by the specified delimiter and unpacks the result into multiple rows, creating an additional column for position index. The delimiter can be one or more specific characters, or a regex pattern to match.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'])
            output_pos = ([, ['output_1'])
    
    Parameters:
    delimiter: Delimiter to be used for splitting the string
    use_regex: Boolean flag indicating whether the specified delimiter should be treated as a regex pattern or an exact match.
    """
    builder = ActionBuilder('split_and_unpack')
    builder.add_input_output('operand', operand)
    builder.add_input_output('output_pos', output_pos)
    if delimiter is not None:
        builder.set_parameter('delimiter', delimiter)
    if use_regex is not None:
        builder.set_parameter('use_regex', use_regex)
    return builder.build()

def split_on_delimiter_to_multicol(input_to_split=None, split_result_item=None,delimiter=None, use_regex=None, include_tail=None):
    """
    For a given column, extracts text components between the delimiters into multiple columns.  The delimiter can be one or more specific characters, or a regex pattern to match.  The number of splits is determined by the number of provided output column names.  Trailing null values are created for records containing fewer components.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            input_to_split = (['input_column_1'], [])
            split_result_item = ([, ['output_1'])
    
    Parameters:
    delimiter: Delimiter to be used for splitting the string
    use_regex: Boolean flag indicating whether the specified delimiter should be treated as a regex pattern or an exact match.
    include_tail: Boolean flag indicating wether the remainder (tail) of the string after the final split must be included in the last column
    """
    builder = ActionBuilder('split_on_delimiter_to_multicol')
    builder.add_input_output('input_to_split', input_to_split)
    builder.add_input_output('split_result_item', split_result_item)
    if delimiter is not None:
        builder.set_parameter('delimiter', delimiter)
    if use_regex is not None:
        builder.set_parameter('use_regex', use_regex)
    if include_tail is not None:
        builder.set_parameter('include_tail', include_tail)
    return builder.build()

def split_to_array(operand=None,delimiter=None, use_regex=None, limit_splits=None, max_number_of_splits=None):
    """
    Obtain array (JSON) columns resulting from splitting the selected text columns using a delimiter or a regex pattern. The number of splits can be specified to be a certain limit, otherwise the splitting of the text is indefinite until no more occurrences of the delimiter are found.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'])
    
    Parameters:
    delimiter: The delimiter to be used for splitting the string.
    use_regex: To split by a regex pattern, set this value to "True".
    limit_splits: Set this to "True" and set the number of splits to the desired number, if not intending to split indefinitely.
    max_number_of_splits: How many splits to obtain at most, if the splits are being limited.
    """
    builder = ActionBuilder('split_to_array')
    builder.add_input_output('operand', operand)
    if delimiter is not None:
        builder.set_parameter('delimiter', delimiter)
    if use_regex is not None:
        builder.set_parameter('use_regex', use_regex)
    if limit_splits is not None:
        builder.set_parameter('limit_splits', limit_splits)
    if max_number_of_splits is not None:
        builder.set_parameter('max_number_of_splits', max_number_of_splits)
    return builder.build()

def strip_html(operand=None,):
    """
    Strip HTML tags from text to convert webpages to text documents, sans HTML formatting
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'])
    
    
    """
    builder = ActionBuilder('strip_html')
    builder.add_input_output('operand', operand)
    return builder.build()

def strip_whitespaces(operand=None,mode=None):
    """
    Strips whitespaces from rows of chosen Text columns.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'])
    
    Parameters:
    mode: The method for stripping the whitespaces. Stripping can be done at the beginning, end, both of the strings, and can even strip ALL of the whitespaces.
    """
    builder = ActionBuilder('strip_whitespaces')
    builder.add_input_output('operand', operand)
    if mode is not None:
        builder.set_parameter('mode', mode)
    return builder.build()

def regex_sub(operand=None,match_pattern=None, sub_pattern=None, sub_string=None):
    """
    Finds and replaces string patterns in a column via Regex. Can optionally specify additional pattern to filter by, in which case the scope of the find/replace will be restricted to records that match the specified pattern in the column.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'])
    
    Parameters:
    match_pattern: Specify this to restrict the scope of replacement
    sub_pattern: The pattern that needs to be substituted
    sub_string: String used to replace values in places where sub_pattern matched the values.
    """
    builder = ActionBuilder('regex_sub')
    builder.add_input_output('operand', operand)
    if match_pattern is not None:
        builder.set_parameter('match_pattern', match_pattern)
    if sub_pattern is not None:
        builder.set_parameter('sub_pattern', sub_pattern)
    if sub_string is not None:
        builder.set_parameter('sub_string', sub_string)
    return builder.build()

def transform_columns_with_formula(transformed=None,formula=None):
    """
    Transforms one or more column(s) with a user-specified formula. Common Excel/SQL functions and operators for manipulating Numeric, DateTime, Text and Boolean values are permitted.For a full list of these functions, see documentation.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            transformed = (['input_column_1'])
    
    Parameters:
    formula: Formula where $COL/$COLUMN refers to the column(s) to be transformed. For example, "col_A + col_B - $COL"
    """
    builder = ActionBuilder('transform_columns_with_formula')
    builder.add_input_output('transformed', transformed)
    if formula is not None:
        builder.set_parameter('formula', formula)
    return builder.build()

def union(secondary_columns=None,allow_secondary_dataset_to_have_missing_columns=None, retain_secondary_dataset_columns=None, promote_column_types=None):
    """
    Perform DataFrame Union on two datasets, i.e. row-append two datasets. Certain column types are incompatible and if the datasets contain these incompatible column types then the DataFrames can not be unioned.

Note: The union is performed by column name and not by column order, unlike in SQL.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            secondary_columns = (['input_column_1'])
    
    Parameters:
    allow_secondary_dataset_to_have_missing_columns: If set to True then union will be allowed even if there are columns missing in the secondary dataset.
    retain_secondary_dataset_columns: Whether to retain columns that are in the secondary dataset but not in the primary dataset.
    promote_column_types: If columns types are different between the two datasets, promote the column types to the same type if possible.
    """
    builder = ActionBuilder('union')
    builder.add_input_output('secondary_columns', secondary_columns)
    if allow_secondary_dataset_to_have_missing_columns is not None:
        builder.set_parameter('allow_secondary_dataset_to_have_missing_columns', allow_secondary_dataset_to_have_missing_columns)
    if retain_secondary_dataset_columns is not None:
        builder.set_parameter('retain_secondary_dataset_columns', retain_secondary_dataset_columns)
    if promote_column_types is not None:
        builder.set_parameter('promote_column_types', promote_column_types)
    return builder.build()

def unpack(operand=None,allow_single_quotes=None):
    """
    Reshape a dataset by unpacking one or more JSON array columns and add a new column for position index
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            operand = (['input_column_1'], ['output_1'])
    
    Parameters:
    allow_single_quotes: Whether to allow single quoted JSONs
    """
    builder = ActionBuilder('unpack')
    builder.add_input_output('operand', operand)
    if allow_single_quotes is not None:
        builder.set_parameter('allow_single_quotes', allow_single_quotes)
    return builder.build()

def unpivot(keys_column=None, values_column=None,):
    """
    Unpivot a dataset from wide to long format. Input columns are converted to a single keys column and one or more values column(s) in the output. Columns other than input columns remain.
    Input/Output:
        operand = ([input1, input2, input3], [output1, output2])
        where
            - input can be a single column name or a single column selector
            - output is a column name or column prefix/suffix
        Example:
            keys_column = ([, ['output_1'])
            values_column = (['input_column_1'], ['output_1'])
    
    
    """
    builder = ActionBuilder('unpivot')
    builder.add_input_output('keys_column', keys_column)
    builder.add_input_output('values_column', values_column)
    return builder.build()
